#pragma once
#include<iostream>
#include<fstream>
#include<time.h>
#include<vector>
#include<algorithm>

void createDataWithStream() {
	std::ofstream file("F.txt");
	srand(time(nullptr));
	if (!file.is_open()) {
		std::cerr << "ERROR";
		exit(EXIT_FAILURE);
	}

	for (int i = 0; i < 100; i++) {
		file << rand() % 101 - 50 << " ";
	}

	file.close();
}

void createDataWithGenerate() {
	std::vector<int> vec(100);
	std::ofstream file("F.txt");
	srand(time(nullptr));
	if (!file.is_open()) {
		std::cerr << "ERROR";
		exit(EXIT_FAILURE);
	}

	std::generate(vec.begin(), vec.end(), []() {return rand() % 101 - 50;});
	std::copy(vec.begin(), vec.end(), std::ostream_iterator<int>(file, " "));

	file.close();
}


template <typename T>
void loadDataWithStream(T& container) {
	std::ifstream file("F.txt");
	if (!file.is_open()) {
		std::cerr << "ERROR";
		exit(EXIT_FAILURE);
	}
	using value_type = typename T::value_type;
	value_type el;
	while (file >> el) {
		container.push_back(el);
	}

	file.close();
}


template <typename T>
void loadDataWithCopy(T& container) {
	std::ifstream file("F.txt");
	if (!file.is_open()) {
		std::cerr << "ERROR";
		exit(EXIT_FAILURE);
	}

	std::copy(std::istream_iterator<int>(file), std::istream_iterator<int>(), back_inserter(container));

	file.close();
}

// modify
//( 20)
//      . 


template <typename T>
T modify1(T& container) {
	auto sum = 0;
	int n = 0;
	T res;
	for (const auto& el : container)
		sum += el;
	for (auto& el : container) {
		if (el > 0) n++;
		if (n == 3) {
			n = 0;
			res.push_back((abs(sum)) / 100);
		}
		else
			res.push_back(el);
	}
	res.push_back(abs(sum));
	res.push_back(abs(sum / 100));
	return res;
}



template <typename T>
void modify2(const T& it_beg, const T& it_end) {
	auto sum = 0;
	int n=0;
	for (auto it = it_beg;it != it_end;++it) {
		sum += *it;
	}
	for (auto it = it_beg;it != it_end;++it) {
		if (*it > 0)  n++;
		if (n == 3) {
			n = 0;
			*it = (abs(sum) / 100);
		}
	}
}


template <typename T>
void modify3(T& container) {
	auto sum = 0;
	for (const auto& el : container)
		sum += el;
	int n = 0;
	auto change = [&sum, &n](auto& el) {
		if (el > 0)  n++;
		if (n == 3) {
			n = 0;
			return (abs(sum) / 100);
		}
		else return el;
	};
	std::for_each(container.begin(), container.end(), change);
}


template <typename T>
void modify4(T& container) {
	using value_type = typename T::value_type;
	std::ifstream file("F.txt");
	std::ofstream file_out("F2.txt");
	if (!file.is_open()) {
		std::cerr << "ERROR";
		exit(EXIT_FAILURE);
	}
	auto sum = 0;
	for (const auto& el : container)
		sum += el;
	int n = 0;
	auto change = [&sum, &n](auto& el) {
		if (el > 0)  n++;
		if (n == 3) {
			n = 0;
			return (abs(sum) / 100);
		}
		else return el;
	};
	std::transform(std::istream_iterator<value_type>(file), std::istream_iterator<value_type>(), std::ostream_iterator<value_type>(file_out, "\t"), change);
}

template<typename T>
void outputResultStream(T& container) {
	std::ofstream file_out("F_res.txt");
	for (const auto& el : container) {
		file_out << el<< " ";
	}
}

template<typename T>
void outputResultCopy(T& container) {
	std::ofstream file_out("F_res.txt");
	using value_type = typename T::value_type;
	std::copy(container.begin(), container.end(), std::ostream_iterator<value_type>(file_out, " "));
}







