#include"file.h"
#include <fstream>
#include <iomanip>
#include<vector>
#include <cmath>
#include <limits>


file::file(const std::string& p_file_name) : file_name(p_file_name) {}

/*bool file::compareDouble(double num1, double num2) {
    return std::fabs(num1 - num2) < std::numeric_limits<double>::epsilon();
}*/

void file::addData() {
    std::ofstream F(file_name, std::ios::binary);
    if (!F.is_open()) {
        std::cerr << "Error: file cannot be opened!" << std::endl;
        exit(EXIT_FAILURE);
    }
    bool isEnd = 0;
    tour new_tour;
    std::cout << "Enter data on a new tour" << std::endl;
    while (!isEnd) {
        std::cout << "Enter tour name, clients surname, price for one day, days of trip, travel price, rate, currency amount, trip price" << std::endl;
        std::cin >> new_tour;
        F.write(reinterpret_cast<const char*>(&new_tour), sizeof(tour));
        std::cout << "press 0 to continue or 1 to coplete" << std::endl;
        std::cin >> isEnd;
    }
}

void file::makeMap(std::map<int, tour>& p_map) {
    tour new_tour;
    std::ifstream file(file_name, std::ios::binary);
    int idx = 0;
    while (file.read(reinterpret_cast<char*>(&new_tour), sizeof(tour))) {
        p_map.insert(std::make_pair(idx, new_tour));
        ++idx;
    }
}

void file::deleteData(int p_idx) {
    std::map<int, tour> map;
    makeMap(map);
    map.erase(p_idx);
    std::ofstream F(file_name, std::ios::binary);
    if (!F.is_open()) {
        std::cerr << "ERROR" << std::endl;
        exit(EXIT_FAILURE);
    }
    for (const auto& new_tour : map) {
        F.write(reinterpret_cast<const char*>(&new_tour.second), sizeof(tour));
    }
}

void file::replaceData(int p_idx, const tour& p_tour) {
    std::map<int, tour> map;
    makeMap(map);
    std::ofstream F(file_name, std::ios::binary);
    if (!F.is_open()) {
        std::cerr << "ERROR" << std::endl;
        exit(EXIT_FAILURE);
    }
    map[p_idx] = p_tour;
    for (const auto& m_tour : map) {
        F.write(reinterpret_cast<const char*>(&m_tour.second), sizeof(tour));
    }
}

void file::toText() {
    std::map<int, tour> map;
    makeMap(map);
    std::string new_file_name = file_name + " .txt";
    std::ofstream F(new_file_name);
    if (!F.is_open()) {
        std::cerr << "ERROR" << std::endl;
        exit(EXIT_FAILURE);
    }

    F << "---------------------------------------------- Agricultural products ---------------------------------------------- " << std::endl;
    F << "| N | TOUR NAME | CLIENTS SURNAME |    ONE DAY PRICE    |  DAYS OF TRIP  |  TRAVEL PRICE  |  RATE  |  CURRENCY AMOUNT |  TRIP PRICE  |" << std::endl;
    size_t n = 0;
    for (const auto& el : map) {
        n++;
        F << "|" << std::setw(3) << n << "|"
            << std::setw(16) << el.second.tour_name << "|"
            << std::setw(16) << el.second.clients_surname << "|"
            << std::setw(16) << el.second.one_day_price << "|"
            << std::setw(16) << el.second.days << "|"
            << std::setw(16) << el.second.travel_price << "|"
            << std::setw(16) << el.second.rate << "|"
            << std::setw(16) << el.second.currency_amount << "|"
            << std::setw(16) << el.second.trip_price << "|"
            << std::endl;
    }
}

void file::searchByName(const std::string& p_tour_name) {
    std::map<int, tour> map;
    makeMap(map);
    std::vector<tour> res;

    for (const auto& p_tour : map) {
        if (p_tour.second.tour_name == p_tour_name) {
            res.push_back(p_tour.second);
        }
    }
    std::ofstream F("res1.bin", std::ios::binary);
    for (const auto& p_tour : res) {
        F.write(reinterpret_cast<const char*>(&p_tour), sizeof(tour));
    }
}

void file::searchBySurname(const std::string& p_surname) {
    std::map<int, tour> map;
    makeMap(map);
    std::vector<tour> res;

    for (const auto& p_tour : map) {
        if (p_tour.second.clients_surname == p_surname) {
            res.push_back(p_tour.second);
        }
    }
    std::ofstream F("res2.bin", std::ios::binary);
    for (const auto& p_tour : res) {
        F.write(reinterpret_cast<const char*>(&p_tour), sizeof(tour));
    }
}

void file::searchByTravelPrice(int p_travel_price) {
    std::map<int, tour> map;
    makeMap(map);
    std::vector<tour> res;

    for (const auto& p_tour : map) {

        if (p_tour.second.travel_price == p_travel_price) {
            res.push_back(p_tour.second);
        }

        /*if (compareDouble(p_tour.second.travel_price, p_travel_price)) {
            res.push_back(p_tour.second);
        }*/
    }
    std::ofstream F("res3.bin", std::ios::binary);
    for (const auto& p_tour : res) {
        F.write(reinterpret_cast<const char*>(&p_tour), sizeof(tour));
    }
}

void file::searchByDays(int p_days) {
    std::map<int, tour> map;
    makeMap(map);
    std::vector<tour> res;

    for (const auto& p_tour : map) {
        if (p_tour.second.days == p_days) {
            res.push_back(p_tour.second);
        }
    }
    std::ofstream F("res4.bin", std::ios::binary);
    for (const auto& p_tour : res) {
        F.write(reinterpret_cast<const char*>(&p_tour), sizeof(tour));
    }
}
