#include"tour.h"

tour::tour(
	const char* p_tour_name,
	const char* p_clients_surname,
	int p_one_day_price,
	int p_days,
	int p_travel_price,
	int p_rate,
	int p_currency_amount,
	int p_trip_price)
	:one_day_price(p_one_day_price)
	, days(p_days)
	, travel_price(p_travel_price)
	, rate(p_rate)
	, currency_amount(p_currency_amount)
	, trip_price(p_trip_price)
{
	strcpy_s(tour_name, p_tour_name);
	strcpy_s(clients_surname, p_clients_surname);
}

tour::tour(const tour& new_tour)
	:one_day_price(new_tour.one_day_price)
	, days(new_tour.days)
	, travel_price(new_tour.travel_price)
	, rate(new_tour.rate)
	, currency_amount(new_tour.currency_amount)
	, trip_price(new_tour.trip_price)
{
	strcpy_s(tour_name, new_tour.tour_name);
	strcpy_s(clients_surname, new_tour.clients_surname);
}

tour& tour::operator=(const tour& p_tour) {
	if (this != &p_tour) {
		strcpy_s(tour_name, p_tour.tour_name);
		strcpy_s(clients_surname, p_tour.clients_surname);
		one_day_price = p_tour.one_day_price;
		days = p_tour.days;
		travel_price = p_tour.travel_price;
		rate = p_tour.rate;
		currency_amount = p_tour.currency_amount;
		trip_price = p_tour.trip_price;
	}
	return *this;
}

std::istream& operator>>(std::istream& p_in, tour& p_tour) {
	p_in >> p_tour.tour_name
		>> p_tour.clients_surname
		>> p_tour.one_day_price
		>> p_tour.days
		>> p_tour.travel_price
		>> p_tour.rate
		>> p_tour.currency_amount
		>> p_tour.trip_price;
	return p_in;
}


std::ostream& operator<<(std::ostream& p_out, const tour& p_tour) {
	p_out << p_tour.tour_name << std::endl
		<< p_tour.clients_surname << std::endl
		<< p_tour.one_day_price << std::endl
		<< p_tour.days << std::endl
		<< p_tour.travel_price << std::endl
		<< p_tour.rate << std::endl
		<< p_tour.currency_amount << std::endl
		<< p_tour.trip_price << std::endl;
	return p_out;
}
